/*
 * Copyright (c) 2020. The Kathra Authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Contributors:
 *    IRT SystemX (https://www.kathra.org/)
 *
 */

package org.kathra.appmanager;

import org.kathra.utils.security.KeycloakUtils;
import org.kathra.core.model.ApiVersion;
import org.apache.camel.model.dataformat.JsonLibrary;
import org.kathra.appmanager.model.ApiFileValidationResponse;
import org.kathra.core.model.CatalogEntry;
import org.kathra.core.model.CatalogEntryPackage;
import org.kathra.appmanager.model.CatalogEntryTemplate;
import org.kathra.core.model.Component;
import org.kathra.core.model.Group;
import org.kathra.core.model.Implementation;
import org.kathra.appmanager.model.ImplementationParameters;
import org.kathra.core.model.Build;
import org.kathra.appmanager.model.Commit;
import org.kathra.KathraAuthRequestHandlerImpl;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.cdi.ContextName;
import org.apache.camel.model.rest.RestBindingMode;
import static org.apache.camel.model.rest.RestParamType.*;

@ContextName("AppManager")
public class AppManagerApi extends RouteBuilder {

    @Override
    public void configure() throws Exception {
        KeycloakUtils.init();
        // configure we want to use servlet as the component for the rest DSL
        // and we enable json binding mode
        restConfiguration().component(org.kathra.iface.KathraAuthRequestHandler.HTTP_SERVER)
        // use json binding mode so Camel automatic binds json <--> pojo
        .bindingMode(RestBindingMode.off)
        // and output using pretty print
        .dataFormatProperty("prettyPrint", "true")
        .dataFormatProperty("json.in.disableFeatures", "FAIL_ON_UNKNOWN_PROPERTIES")
        // setup context path on localhost and port number that netty will use
        .contextPath("/api/v1")
        .port("{{env:HTTP_PORT:8080}}")
        .componentProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))
        .endpointProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))
        .consumerProperty("chunkedMaxContentLength", String.valueOf( 1400 * 1024 * 1024))

        // add swagger api-doc out of the box
        .apiContextPath("/swagger.json")
        .apiProperty("api.title", "Kathra Applications Manager")
        .apiProperty("api.version", "1.2.0")
        .apiProperty("api.description", "AppManager")
        // and enable CORS
        .apiProperty("cors", "true")
        .enableCORS(true).corsAllowCredentials(true)
        .corsHeaderProperty("Access-Control-Allow-Headers", "Origin, Accept, X-Requested-With, Content-Type," +
                "Access-Control-Request-Method, Access-Control-Request-Headers, Authorization");

        rest()

        .post("/components/{componentId}/apiVersions").outType(ApiVersion.class).consumes("multipart/form-data")
            .description("Create a new ApiVersion via an OpenAPI file")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("componentId")
                    .type(path)
                    .description("The ID of the Component the APIVersion will be created for")
                .endParam()
                .param()
                    .required(false)
                    .dataType("file")
                    .name("openApiFile")
                    .type(formData)
                    .description("The OpenAPI file representing the APIVersion to create")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=createApiVersion(${header.componentId},${header.openApiFile})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/apiVersions/{apiVersionId}").outType(ApiVersion.class).consumes("multipart/form-data")
            .description("Delete ApiVersion via an OpenAPI file")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("apiVersionId")
                    .type(path)
                    .description("The ID of the Component the APIVersion will be deleted for")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=deleteApiVersion(${header.apiVersionId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/apiVersions/{apiVersionId}/apiFile").consumes("multipart/form-data")
            .description("Get the API File from the specified source repository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("apiVersionId")
                    .type(path)
                    .description("The ID of the requested APIVersion file")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=getApiFile(${header.apiVersionId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
            .endRest()

        .get("/apiVersions/{apiVersionId}").outType(ApiVersion.class)
            .description("Get the Api Version having the given id")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("apiVersionId")
                    .type(path)
                    .description("The ID of the Api Version to get")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=getApiVersionById(${header.apiVersionId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .put("/apiVersions/{apiVersionId}").outType(ApiVersion.class).consumes("multipart/form-data")
            .description("Update ApiVersion via an OpenAPI file")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("apiVersionId")
                    .type(path)
                    .description("The ID of the Component the APIVersion will be created for")
                .endParam()
                .param()
                    .required(false)
                    .dataType("file")
                    .name("openApiFile")
                    .type(formData)
                    .description("The OpenAPI file representing the APIVersion to create")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ApiVersionsController?method=updateApiVersion(${header.apiVersionId},${header.openApiFile})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/apiFileValidation").outType(ApiFileValidationResponse.class).consumes("multipart/form-data").produces("application/json")
            .description("Check the integrity of an API file")
                .param()
                    .required(true)
                    .dataType("file")
                    .name("apiFile")
                    .type(formData)
                    .description("API specification of the component's API")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleRequest")
                .to("bean:AppManagerController?method=getApiFileValidation(${header.apiFile})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/catalog-entries").type(CatalogEntryTemplate.class).outType(CatalogEntry.class)
            .description("Add a new entry to catalog from template")
                .param()
                    .required(false)
                    .name("catalogEntry")
                    .type(body)
                    .description("The catalog entry to create from template")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,CatalogEntryTemplate.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=addEntryToCatalogFromTemplate(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/catalog-entries/{catalogEntryId}").outType(CatalogEntry.class)
            .description("Delete the CatalogEntry having the given id")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("catalogEntryId")
                    .type(path)
                    .description("The ID of the CatalogEntry to delete")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=deleteCatalogEntryById(${header.catalogEntryId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalog-entries").outType(CatalogEntry[].class)
            .description("Get the catalog entries list")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=getCatalogEntries")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalog-entries/{catalogEntryId}").outType(CatalogEntry.class)
            .description("Get the CatalogEntry having the given id")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("catalogEntryId")
                    .type(path)
                    .description("The ID of the CatalogEntryId to get")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=getCatalogEntry(${header.catalogEntryId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalog-entries-packages/{providerId}").outType(CatalogEntryPackage.class)
            .description("Get the CatalogEntryPackage having the given ProviderID [latest version]")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("providerId")
                    .type(path)
                    .description("The ProviderId of the CatalogEntryPackage to get")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=getCatalogEntryPackageFromProviderId(${header.providerId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalog-entries-packages/{providerId}/versions/{version}").outType(CatalogEntryPackage.class)
            .description("Get the CatalogEntryPackage having the given ProviderID and version")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("providerId")
                    .type(path)
                    .description("The ProviderId of the CatalogEntryPackage to get")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("version")
                    .type(path)
                    .description("The Version of the CatalogEntryPackage to get")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=getCatalogEntryPackageFromProviderIdAndVersion(${header.providerId},${header.version})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalog-entries-packages/").outType(CatalogEntryPackage[].class)
            .description("Get all CatalogEntryPackage with ProviderID")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=getCatalogEntryPackages")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/catalog-entries-templates").outType(CatalogEntryTemplate[].class)
            .description("Get codegen templates")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:CatalogEntriesController?method=getCatalogEntryTemplates")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/components").type(Component.class).outType(Component.class)
            .description("Create a new Component")
                .param()
                    .required(false)
                    .name("component")
                    .type(body)
                    .description("The parameters for the component to create. Required: name and metadata.groupPath")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,Component.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=createComponent(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/components/{componentId}").outType(Component.class)
            .description("Delete the component having the given id")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("componentId")
                    .type(path)
                    .description("The ID of the Component to delete")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=deleteComponentById(${header.componentId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/components/{componentId}").outType(Component.class)
            .description("Get the component having the given id")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("componentId")
                    .type(path)
                    .description("The ID of the Component to get")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=getComponentById(${header.componentId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/components").outType(Component[].class)
            .description("Get the components list")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ComponentsController?method=getComponents")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/groups").outType(Group[].class)
            .description("Get the groups list")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:GroupsController?method=getGroups")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/implementations").type(ImplementationParameters.class).outType(Implementation.class)
            .description("Create a new Implementation for the given ApiVersion")
                .param()
                    .required(false)
                    .name("implementationParameters")
                    .type(body)
                    .description("The parameters for the implementation to create")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .unmarshal().json(JsonLibrary.Gson,ImplementationParameters.class)
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=createImplementation(${body})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .delete("/implementations/{implementationId}").outType(Implementation.class)
            .description("Delete the Implementation having the given id")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("implementationId")
                    .type(path)
                    .description("The ID of the Implementation to delete")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=deleteImplementationById(${header.implementationId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/components/{componentId}/implementations").outType(Implementation[].class)
            .description("Get the component having the given id")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("componentId")
                    .type(path)
                    .description("The ID of the Component to get the implementations from")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=getComponentImplementations(${header.componentId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/implementations/{implementationId}").outType(Implementation.class)
            .description("Get the Implementation having the given id")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("implementationId")
                    .type(path)
                    .description("The ID of the Implementation to get")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=getImplementationById(${header.implementationId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/implementations").outType(Implementation[].class)
            .description("Get the Implementations list")
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:ImplementationsController?method=getImplementations")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .post("/pipelines/{pipelineId}/builds").outType(Build.class)
            .description("Execute pipeline")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("pipelineId")
                    .type(path)
                    .description("The ID of the Pipeline to get the builds of")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("branch")
                    .type(query)
                    .description("The name of the branch to get the builds of")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:PipelinesController?method=executePipeline(${header.pipelineId},${header.branch})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/pipelines/{pipelineId}/builds").outType(Build[].class)
            .description("Get the builds for the given pipeline for a given branch")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("pipelineId")
                    .type(path)
                    .description("The ID of the Pipeline to get the builds of")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("branch")
                    .type(query)
                    .description("The name of the branch to get the builds of")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:PipelinesController?method=getPipelineBuildsForBranch(${header.pipelineId},${header.branch})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/sourceRepositories/branches/{sourceRepositoryId}").outType(String[].class)
            .description("Get the branches for the given SourceRepository")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryId")
                    .type(path)
                    .description("The ID of the SourceRepository to get")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:RepositoriesController?method=getRepositoryBranches(${header.sourceRepositoryId})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest()

        .get("/commits/{sourceRepositoryId}").outType(Commit[].class)
            .description("Get the commits for the given SourceRepository for a given branch")
                .param()
                    .required(true)
                    .dataType("string")
                    .name("sourceRepositoryId")
                    .type(path)
                    .description("The ID of the SourceRepository to get the commits from")
                .endParam()
                .param()
                    .required(true)
                    .dataType("string")
                    .name("branch")
                    .type(query)
                    .description("The name of the branch to get the commits from")
                .endParam()
            .route().onException(Exception.class)
                    .bean(KathraAuthRequestHandlerImpl.class,"handleException")
                    .bean(KathraAuthRequestHandlerImpl.class,"deleteSession")
                    .handled(true).stop().end()
                .bean(KathraAuthRequestHandlerImpl.class,"handleAuthenticatedRequest")
                .to("bean:RepositoriesController?method=getRepositoryCommitsForBranch(${header.sourceRepositoryId},${header.branch})")
                .bean(KathraAuthRequestHandlerImpl.class,"postProcessResponse")
                .marshal().json(JsonLibrary.Gson)
            .endRest();
    }
}